// podprogramy pro praci s SD kartou
//================================================


char jmeno_souboru[] = "20190125.csv";                                      // retezec pro konstrukci jmena souboru
char jmeno_slozky[] = "2019";                                               // retezec pro konstrukci nazvu slozky
char cesta[] = "2019/20190125.csv";                                         // retezec pro konstrukci cele cesty k souboru


//----------------------------------------------
//  zapis dat na kartu do souboru (\rok\yyyymmdd.csv)
//  vcetne nastaveni datumu a casu posledniho zapisu souboru do FAT
void SD_save(void)
  {
#ifdef pouzivat_SD_kartu                                                    // kdyz je nastaveno pouzivani SD karty, tak se muze ukladat

    // nejdriv zjistit, jestli je dneska pred polednem, nebo po poledni. Podle toho se urci jmeno souboru.
    //  Kdyz je dnesek jeste pred polednem, uklada se do souboru s predchozim dnem
    unsigned long tt = rtc_korekce();                                       // aktualni cas v RTC v sekundach od 1.1.1970
    sek1970_datcas(tt,false);

    // mtt_file se pouziva k vytvoreni jmena souboru a slozky, a proto tam muze byt nekdy i vcerejsek
    if (mtt.hour < 12)                                                      // od pulnoci se cele dopoledne dnesniho dne ulkada jeste do vcerejsiho souboru
      {
        tt_file = tt - 43200UL;                                             // datum je o 12 hodin starsi (vcerejsi)
        rtclock.breakTime(tt_file,mtt_file);
      }
    else                                                                    // od poledne az do nasledujici pulnoci se uz vytvari normalni dnesni soubor
      {
        rtclock.breakTime(tt,mtt_file);
      }

    // den, mesic a rok pro jmeno souboru a slozky
    LOC_den_file = mtt_file.day;
    LOC_mes_file = mtt_file.month;
    LOC_rok_file = mtt_file.year+1970;


    rokmesden = LOC_rok_file * 10000 + LOC_mes_file*100 + LOC_den_file;     // zacatek obdobi, pro ktere plati zaznamenane hodnoty (napriklad pri aktualnim case "23.5.2019 16:48" se zaznamena 20190523)

    
    jmeno_slozky[0]  = 48 + ((LOC_rok_file % 10000) / 1000 );               // tisice let
    jmeno_slozky[1]  = 48 + ((LOC_rok_file % 1000)  /  100 );               // stovky let
    jmeno_slozky[2]  = 48 + ((LOC_rok_file % 100)   /   10 );               // desitky let
    jmeno_slozky[3]  = 48 + ((LOC_rok_file % 10))           ;               // jednotky roku
    
    jmeno_souboru[0]  = 48 + ((rokmesden % 100000000)   /  10000000 );      // rad tisicu roku
    jmeno_souboru[1]  = 48 + ((rokmesden % 10000000)    /   1000000 );      // rad stovek roku
    jmeno_souboru[2]  = 48 + ((rokmesden % 1000000)     /    100000 );      // rad desitek roku
    jmeno_souboru[3]  = 48 + ((rokmesden % 100000)      /     10000 );      // rad jednotek roku
    jmeno_souboru[4]  = 48 + ((rokmesden % 10000)       /      1000 );      // rad desitek mesicu
    jmeno_souboru[5]  = 48 + ((rokmesden % 1000)        /       100 );      // rad jednotek mesicu
    jmeno_souboru[6]  = 48 + ((rokmesden % 100)         /        10 );      // rad desitek dni
    jmeno_souboru[7]  = 48 + ((rokmesden % 10)                      );      // rad jednotek dni

//  jmeno_souboru[8]  = '.';      // tyhle znaky se nemeni
//  jmeno_souboru[9]  = 'c';
//  jmeno_souboru[10] = 's';
//  jmeno_souboru[11] = 'v';
//  jmeno_souboru[12] = '\0';

    for ( i = 0; i< 4 ; i++)
      {
        cesta[i] = jmeno_slozky[i];
      }

    cesta[4] = '/';
    for ( i = 5; i< 18 ; i++)
      {
        cesta[i] = jmeno_souboru[i-5];
      }


    if (digitalRead(pin_karta_IN) == LOW)                                   // LOW = karta zasunuta, muze se provest pokus o zapis
      {
        sd.begin(pin_SD_CS,SD_SCK_HZ(F_CPU/4));                             //inicializace SD karty pro pripad, ze by byla predtim vytazena
    
        if (!sd.exists(jmeno_slozky)) 
          {
            sd.mkdir(jmeno_slozky);            
          }

        boolean novy_soubor;
        if (!sd.exists(cesta))   novy_soubor = true;                        // Soubor neexistuje - bude se zapisovat hlavicka
        else                     novy_soubor = false;                       // Soubor uz existuje - hlavicka se zapisovat nebude
    
    
        SdFile::dateTimeCallback(dateTime);
       
        open_OK = soubor.open(cesta, O_WRITE | O_APPEND | O_CREAT);

        if (open_OK)
          {
            if (vytvaret_hlavicku == true and novy_soubor == true)
              {
                soubor.println(hlavicka);  
              }
            soubor.println(vystupni_retezec); 
            soubor.close();
          }    
        else
          {
#ifdef displej_TM1637_5
            zobraz_text(37);                                                // na displeji napis 5d-Er = chyba karty
#endif
#ifdef signal_LED
            analogWrite(pin_LED_B, 200);                                    // rozsvitit modrou LED
#endif
            
            tone(pin_bzuk,500, 100);                                        // chybove pipnuti
            delay(2000);
          }
        
      }
    else                                                                    // karta je vysunuta, nic se nezapisuje
      {
#ifdef signal_LED
            blik_B();                                                       // pri vysunute karte blikne modrou LED     
#endif
      }

#endif                                                                      // kdyz neni nastaveno pouzivani SD karty, tak se ukladaci podprogram preskakuje
  }
//----------------------------------------------
    


//----------------------------------------------
// podprogram pro nastavovani datumu a casu u souboru na SD karte:
// zdroj:  https://forum.arduino.cc/index.php?topic=348562.0
void dateTime(uint16_t* date, uint16_t* time)
  {
    *date = FAT_DATE(LOC_rok, LOC_mes, LOC_den);
    *time = FAT_TIME(LOC_hod, LOC_min, LOC_sek);
  }
//----------------------------------------------



//----------------------------------------------
// prevede cast pole prijato[] na integer   
//    (reseni s podprogramem je hlavne kvuli uspore mista v PROGMEM - prevzal jsem to z jineho sveho programu a uz se mi to nechtelo predelavat)
// priklad:                            prijato = { 50,  48,  49,  56}
// v ASCII znacich to je               prijato = {'2', '0', '1', '8'}
//   tak zavolani funkce  "prijato_int(0,4)" vrati cislo 2018
unsigned int prijato_int( byte znak_start, byte znak_stop)
  {
    unsigned int soucet = 0;
    unsigned int mocnina;
    for (i = znak_start; i < znak_stop; i++)
      {
    
        switch (znak_stop - i)
          {
            case 1:
              mocnina = 1;
              break;
            case 2:
              mocnina = 10;
              break;
            case 3:
              mocnina = 100;
              break;
            case 4:
              mocnina = 1000;
              break;
          }
      
        soucet = soucet + (prijato[i] - '0') * mocnina ;
      }
    return soucet;
  }
//----------------------------------------------
